# makeE.sh with CShell

set OBJ MANX:TextPlus/ObjE/
set SRC MANX:TextPlus/SrcE/
set ALL $OBJ"mainE.o" $OBJ"miscE.o" $OBJ"buchstabeE.o" $OBJ"printerE.o" $OBJ"blockE.o" $OBJ"autotrennE.o\
" $OBJ"includeE.o" $OBJ"fs1.o" $OBJ"fs2.o" $OBJ"fsdata.o" $OBJ"gadgetsE.o"
set DST Manx:TextPlus/ObjE/TextPlus2.2E
set FLG -3 +l +i$OBJ"inclE.o"

if -t $OBJ"inclE.o" $SRC"includeE.h" $SRC"defsE.h" $SRC"menuE.h"
   c:echo "Compiling *e[33m headerfiles *e[0m ..."
   cc -3 +l +H$OBJ"inclE.o" $SRC"includeE.h"
   cc -3 +l -o $OBJ"includeE.o" $SRC"includeE.h"
endif

if -t $OBJ"fs1.o" $SRC"fs1.c"
   c:echo "Compiling *e[33m fs1.c *e[0m to *e[33m fs1.o *e[0m ..."
   cc -o $OBJ"fs1.o" $SRC"fs1.c"
endif
if -t $OBJ"fsdata.o" $SRC"fsdata.c"
   c:echo "Compiling *e[33m fsdata.c *e[0m to *e[33m fsdata.o *e[0m ..."
   cc -o $OBJ"fsdata.o" $SRC"fsdata.c"
endif
if -t $OBJ"fs2.o" $SRC"fs2.asm"
   c:echo "Assembling *e[33m fs2.asm *e[0m to *e[33m fs2.o *e[0m ..."
   MANX:Aztec/Bin/as -o $OBJ"fs2.o" $SRC"fs2.asm"
endif

foreach i ( mainE miscE buchstabeE printerE blockE autotrennE gadgetsE ) "if -t $OBJ$i\".o\" $SRC$i\".c\"; c:echo \"Compiling \
*e[33m \"$SRC$i\".c *e[0m to *e[33m \"$OBJ$i\".o *e[0m ...\"; cc $FLG \"-o\" $OBJ$i\".o\" $SRC$i\".c\"; endif"

if -t $DST $OBJ"mainE.o" $OBJ"miscE.o" $OBJ"buchstabeE.o" $OBJ"printerE.o" $OBJ"blockE.o" $OBJ"autotrennE.o" $OBJ"gadgetsE.o" $OBJ"includeE.o"
   c:echo "Linking everything to  *e[33m "$DST" *e[0m ..."
   ln +Cd +q -o $DST $ALL detach.ols -lc
endif
