/*
 *       menuE.h               by Martin Steppler
 */

#define NFLAG ITEMTEXT|ITEMENABLED|HIGHCOMP             /* normal item  */
#define IFLAG ITEMTEXT|ITEMENABLED|HIGHIMAGE            /* with image   */
#define HFLAG ITEMTEXT|ITEMENABLED|HIGHCOMP|COMMSEQ     /* hot key      */
#define LFLAG ITEMTEXT|ITEMENABLED                      /* line         */
#define CFLAG ITEMTEXT|ITEMENABLED|HIGHCOMP|CHECKIT     /* checkit      */
#define IHEIGHT  8
#define SUCHENWIDTH   135
#define SCHRIFTWIDTH  159
#define EINWIDTH      175
#define EDITWIDTH     151
#define DOKUWIDTH     143

/* Suchen Item IntuiText */
struct IntuiText SuchenText[] =
{
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Find",             NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"  next",           NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"  previous",       NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Replace",          NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"  next",           NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"  previous",       NULL}
};

struct MenuItem SuchenItem[] =
{
                                                      /* Suchen */
   {&SuchenItem[1], 0,   1, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[0], NULL,  'f', NULL, MENUNULL},
                                                      /*     vorwrts */
   {&SuchenItem[2], 0,  11, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[1], NULL,  '1', NULL, MENUNULL},
                                                      /*     rckwrts */
   {&SuchenItem[3], 0,  21, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[2], NULL,  '2', NULL, MENUNULL},
                                                      /* ------------- */
   {&SuchenItem[4], 0,  31, SUCHENWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&SuchenText[3], NULL, EOS, NULL, MENUNULL},
                                                      /* Ersetzen */
   {&SuchenItem[5], 0,  41, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[4], NULL,  'r', NULL, MENUNULL},
                                                      /*     vorwrts */
   {&SuchenItem[6], 0,  51, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[5], NULL,  '3', NULL, MENUNULL},
                                                      /*     rckwrts */
   {NULL,           0,  61, SUCHENWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SuchenText[6], NULL,  '4', NULL, MENUNULL}
};
/* Schrift Item IntuiText */
struct IntuiText SchriftText[] =
{
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Normal",              NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Underline",           NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Bold",                NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Italic",              NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Left aligned",        NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Right aligned",       NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Centered",            NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Justification",       NULL}
};
struct MenuItem SchriftItem[] =
{
                                                      /* Normal */
   {&SchriftItem[1], 0,   1, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[0], NULL,  'n', NULL, MENUNULL},
                                                      /* Unterstrichen */
   {&SchriftItem[2], 0,  11, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[1], NULL,  'u', NULL, MENUNULL},
                                                      /* Fett */
   {&SchriftItem[3], 0,  21, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[2], NULL,  'b', NULL, MENUNULL},
                                                      /* Kursiv */
   {&SchriftItem[4], 0,  31, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[3], NULL,  'i', NULL, MENUNULL},
                                                      /* ------------- */
   {&SchriftItem[5], 0,  41, SCHRIFTWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&SchriftText[4], NULL, EOS, NULL, MENUNULL},
                                                      /* Linksbndig */
   {&SchriftItem[6], 0,  51, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[5], NULL,  'l', NULL, MENUNULL},
                                                      /* Rechtssbndig */
   {&SchriftItem[7], 0,  61, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[6], NULL,  'e', NULL, MENUNULL},
                                                      /* Zentriert */
   {&SchriftItem[8], 0,  71, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[7], NULL,  'c', NULL, MENUNULL},
                                                      /* Blocksatz */
   {NULL,            0,  81, SCHRIFTWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&SchriftText[8], NULL,  'j', NULL, MENUNULL}
};
/* Einstellungen Item IntuiText */
struct IntuiText EinText[] =
{
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Length of page",        NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Width of text",         NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"---------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"    Insert        C-e", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"    Letter        C-r", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"    Auto-Div      C-a", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"    Backup        C-p", NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"---------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Go to ...         C-g", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Go to line x      C-l", NULL}
};
struct MenuItem EinItem[] =
{
                                                      /* Seitenlnge */
   {&EinItem[1], 0,   1, EINWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&EinText[0], NULL,  'o', NULL, MENUNULL},
                                                      /* Textbreite */
   {&EinItem[2], 0,  11, EINWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&EinText[1], NULL,  't', NULL, MENUNULL},
                                                      /* ------------- */
   {&EinItem[3], 0,  21, EINWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EinText[2], NULL, EOS, NULL, MENUNULL},
                                                      /* Einfgen */
   {&EinItem[4], 0,  31, EINWIDTH, IHEIGHT, CFLAG, 0,
    (APTR)&EinText[3], NULL, EOS, NULL, MENUNULL},
                                                      /* Brief */
   {&EinItem[5], 0,  41, EINWIDTH, IHEIGHT, CFLAG, 0,
    (APTR)&EinText[4], NULL, EOS, NULL, MENUNULL},
                                                      /* Auto-Trenn */
   {&EinItem[6], 0,  51, EINWIDTH, IHEIGHT, CFLAG, 0,
    (APTR)&EinText[5], NULL, EOS, NULL, MENUNULL},
                                                      /* Backup */
   {&EinItem[7], 0,  61, EINWIDTH, IHEIGHT, CFLAG, 0,
    (APTR)&EinText[6], NULL, EOS, NULL, MENUNULL},
                                                      /* ------------- */
   {&EinItem[8], 0,  71, EINWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EinText[7], NULL, EOS, NULL, MENUNULL},
                                                      /* Gehe zu ... */
   {&EinItem[9], 0,  81, EINWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EinText[8], NULL, EOS, NULL, MENUNULL},
                                                      /* Gehe zur x. Zeile */
   {NULL,        0,  91, EINWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EinText[9], NULL, EOS, NULL, MENUNULL}
};
/* Editieren Item IntuiText */
struct IntuiText EditText[] =
{
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Mark block     C-b", NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Copy block     C-c", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Delete block   C-x", NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Delete Mark    C-l", NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Load block",         NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Save block",         NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"------------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Print block",        NULL}
};
struct MenuItem EditItem[] =
{
                                                      /* Block markieren */
   {&EditItem[1], 0,   1, EDITWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EditText[0], NULL, EOS, NULL, MENUNULL},
                                                      /* ------------- */
   {&EditItem[2], 0,  11, EDITWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EditText[1], NULL, EOS, NULL, MENUNULL},
                                                      /* Block kopieren */
   {&EditItem[3], 0,  21, EDITWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EditText[2], NULL, EOS, NULL, MENUNULL},
                                                      /* Block lschen */
   {&EditItem[4], 0,  31, EDITWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EditText[3], NULL, EOS, NULL, MENUNULL},
                                                      /* ------------- */
   {&EditItem[5], 0,  41, EDITWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EditText[4], NULL, EOS, NULL, MENUNULL},
                                                      /* Markierung lschen */
   {&EditItem[6], 0,  51, EDITWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&EditText[5], NULL, EOS, NULL, MENUNULL},
                                                      /* ------------- */
   {&EditItem[7], 0,  61, EDITWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EditText[6], NULL, EOS, NULL, MENUNULL},
                                                      /* Block laden */
   {&EditItem[8], 0,  71, EDITWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&EditText[7], NULL,  'k', NULL, MENUNULL},
                                                      /* Block speichern */
   {&EditItem[9], 0,  81, EDITWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&EditText[8], NULL,  'm', NULL, MENUNULL},
                                                      /* ------------- */
   {&EditItem[10],0,  91, EDITWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&EditText[9], NULL, EOS, NULL, MENUNULL},
                                                      /* Block drucken */
   {NULL,         0, 101, EDITWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&EditText[10],NULL,  'z', NULL, MENUNULL}
};
/* Dokument Item IntuiText */
struct IntuiText DokuText[] =
{
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Load",              NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Append file",       NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Delete file",       NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Save",              NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Save as ...",       NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Save & Quit",       NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Print",             NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Iconify",           NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Help         HELP", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"About",             NULL},
   {ROT    ,WEISS,JAM2,2,0, NULL, (UBYTE *)"-----------------", NULL},
   {SCHWARZ,WEISS,JAM2,2,0, NULL, (UBYTE *)"Quit          ESC", NULL}
};
struct IntuiText DokuSelect[] = {
   {ROT,    WEISS,JAM2,2,0, NULL, (UBYTE *)" REALLY? ",      NULL},
   {ROT,    WEISS,JAM2,2,0, NULL, (UBYTE *)"BYE BYE 8-)",       NULL}
};
struct MenuItem DokuItem[] =
{
                                                      /* Laden */
   {&DokuItem[1], 0,   1, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[0], NULL,  'g', NULL, MENUNULL},
                                                      /* Text anhngen */
   {&DokuItem[2], 0,  11, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[1], NULL,  'a', NULL, MENUNULL},
                                                      /* ------------- */
   {&DokuItem[3], 0,  21, DOKUWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&DokuText[2], NULL, EOS, NULL, MENUNULL},
                                                      /* Text lschen */
   {&DokuItem[4], 0,  31, DOKUWIDTH, IHEIGHT, IFLAG|COMMSEQ, 0,
    (APTR)&DokuText[3], (APTR)&DokuSelect[0],  'd', NULL, MENUNULL},
                                                      /* ------------- */
   {&DokuItem[5], 0,  41, DOKUWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&DokuText[4], NULL, EOS, NULL, MENUNULL},
                                                      /* Speichern */
   {&DokuItem[6], 0,  51, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[5], NULL,  'w', NULL, MENUNULL},
                                                      /* Speichern als ... */
   {&DokuItem[7], 0,  61, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[6], NULL,  's', NULL, MENUNULL},
                                                      /* Speichern & Beenden */
   {&DokuItem[8], 0,  71, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[7], NULL,  'q', NULL, MENUNULL},
                                                      /* ------------- */
   {&DokuItem[9], 0,  81, DOKUWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&DokuText[8], NULL, EOS, NULL, MENUNULL},
                                                      /* Drucken */
   {&DokuItem[10],0,  91, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[9], NULL,  'p', NULL, MENUNULL},
                                                      /* ------------- */
   {&DokuItem[11],0, 101, DOKUWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&DokuText[10],NULL, EOS, NULL, MENUNULL},
                                                      /* Iconify */
   {&DokuItem[12],0, 111, DOKUWIDTH, IHEIGHT, HFLAG, 0,
    (APTR)&DokuText[11],NULL,  'y', NULL, MENUNULL},
                                                      /* Hilfe */
   {&DokuItem[13],0, 121, DOKUWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&DokuText[12],NULL, EOS, NULL, MENUNULL},
                                                      /* Info */
   {&DokuItem[14],0, 131, DOKUWIDTH, IHEIGHT, NFLAG, 0,
    (APTR)&DokuText[13],NULL, EOS, NULL, MENUNULL},
                                                      /* ------------- */
   {&DokuItem[15],0, 141, DOKUWIDTH, IHEIGHT, LFLAG, 0,
    (APTR)&DokuText[14],NULL, EOS, NULL, MENUNULL},
                                                      /* Ende */
   {NULL,         0, 151, DOKUWIDTH, IHEIGHT, IFLAG, 0,
    (APTR)&DokuText[15], (APTR)&DokuSelect[1], EOS, NULL, MENUNULL}
};
/* Menu Titles */
struct Menu Menus[] =
{
   {&Menus[1],  0, 0, 63, 0, MENUENABLED, "Project", &DokuItem[0]   },
   {&Menus[2], 83, 0, 39, 0, MENUENABLED, "Edit",    &EditItem[0]   },
   {&Menus[3],142, 0, 47, 0, MENUENABLED, "Prefs",   &EinItem[0]    },
   {&Menus[4],209, 0, 47, 0, MENUENABLED, "Style",   &SchriftItem[0]},
   {NULL,     276, 0, 39, 0, MENUENABLED, "Find",    &SuchenItem[0] },
};

struct IntuiText request_text =
   {SCHWARZ,WEISS,JAM2,13,10, NL, NL,                NL };
struct IntuiText ja_text =
   {   BLAU,WEISS,JAM1, 7, 3, NL, (UBYTE *) "YES!",   NL };
struct IntuiText nein_text =
   {    ROT,WEISS,JAM2, 7, 3, NL, (UBYTE *) "NO!", NL };

char *FehlerText[] = {
   "Begin of file!",
   "End of file!",
   "End of text-memory!"
};
char *FrageText[] = {
   "   Quit without saving changes?   ",
   "      Delete modified file?       ",
   "       Overwrite old file?        ",
   "         Save and Quit?           "
};
char *TitelText[] = {
   "LOAD FILE>    ",
   "APPEND FILE>    ",
   "SAVE FILE>    ",
   "LOAD BLOCK>    ",
   "SAVE BLOCK>    ",
   "PRINT FILE",
   "PRINT BLOCK",
   "Page-length",
   "Text-width"
};

struct IntuiText InfoText[] =
{
   {SCHWARZ,WEISS,JAM2,13,  8,NULL, (UBYTE *)"Text Plus V2.2E (06.08.90)  by       ", &InfoText[ 1] },
   {SCHWARZ,WEISS,JAM2,13, 16,NULL, (UBYTE *)"                                      ", &InfoText[ 2] },
   {ROT,    WEISS,JAM2,13, 24,NULL, (UBYTE *)"           Martin Steppler            ", &InfoText[ 3] },
   {ROT,    WEISS,JAM2,13, 32,NULL, (UBYTE *)"        Dr.-Danzebrink-Str. 11        ", &InfoText[ 4] },
   {ROT,    WEISS,JAM2,13, 40,NULL, (UBYTE *)"            D-6400 Fulda              ", &InfoText[ 5] },
   {ROT,    WEISS,JAM2,13, 48,NULL, (UBYTE *)"         Fed. Rep. of Germany         ", &InfoText[ 6] },
   {SCHWARZ,WEISS,JAM2,13, 56,NULL, (UBYTE *)"                                      ", &InfoText[ 7] },
   {SCHWARZ,WEISS,JAM2,13, 64,NULL, (UBYTE *)"Text Plus is SHAREWARE. Sending me the", &InfoText[ 8] },
   {SCHWARZ,WEISS,JAM2,13, 72,NULL, (UBYTE *)"SHARE ($15) will make you get the  la-", &InfoText[ 9] },
   {SCHWARZ,WEISS,JAM2,13, 80,NULL, (UBYTE *)"test update.                          ", &InfoText[10] },
   {BLAU,   WEISS,JAM2,13, 88,NULL, (UBYTE *)"ADVICE for all PD-distributors:       ", &InfoText[11] },
   {SCHWARZ,WEISS,JAM2,13, 96,NULL, (UBYTE *)"Text  Plus  V2.2E must not be added to", &InfoText[12] },
   {SCHWARZ,WEISS,JAM2,13,104,NULL, (UBYTE *)"a  PD-library  without my consent. The", &InfoText[13] },
   {SCHWARZ,WEISS,JAM2,13,112,NULL, (UBYTE *)"price must not  exceed  the  costs  of", &InfoText[14] },
   {SCHWARZ,WEISS,JAM2,13,120,NULL, (UBYTE *)"disk, package and mailing.            ", &InfoText[15] },
   {SCHWARZ,WEISS,JAM2,13,128,NULL, (UBYTE *)"Source of this version:               ", &InfoText[16] },
   {ROT,    WEISS,JAM2,13,136,NULL, (UBYTE *)"  Author                              ", &InfoText[17] },
   {BLAU,   WEISS,JAM2,13,144,NULL, (UBYTE *)"                               Martin ", NULL          }
};
char *HilfeText[] = {
   "   KEYMAP", " ",
   "   CONTROL          -q   save and Quit",
   "                    -t   display length and end of Text",
   "           -n/-u/-o/-k   style: Normal / Underline / bOld / italiK",
   " ",
   "   SHIFT-DEL             delete line",
   "   SHIFT-CR              insert last deleted line",
   "   CTRL -BS/DEL          delete begin / rest of line",
   "   ALT  -BS/DEL          delete previous / next word",
   "   SHIFT-BS              delete spaces",
   "   CTRL/ALT-TAB          move line to the previous/next tab-stop or",
   "                         move block to the previous/next tab-stop",
   "   CTRL -CRSR-LFT/RGT    move block left/right",
   "   SHIFT-CRSR-UP/DOWN    jump to top/bottom of window or 18 lines up/down",
   "   ALT  -CRSR-UP/DOWN    jump to begin/end of text",
   "   CTRL -CRSR-UP/DOWN    jump to begin of previous/next page",
   "   SHIFT-CRSR-LFT/RGT    jump to begin/end of line",
   "   ALT  -CRSR-LFT/RGT    jump to previous/next word"
};

#define RRAND        620
#define IDCMPFLAGS   CLOSEWINDOW|MENUPICK|MOUSEBUTTONS|MOUSEMOVE|NEWSIZE|RAWKEY|INTUITICKS|GADGETUP
#define ICONIDCMP    CLOSEWINDOW|MENUPICK|MOUSEBUTTONS
#define FLAGS        SMART_REFRESH|ACTIVATE|WINDOWCLOSE|WINDOWDRAG|WINDOWDEPTH|WINDOWSIZING|GIMMEZEROZERO|REPORTMOUSE
#define ICONFLAGS    SMART_REFRESH|WINDOWCLOSE|WINDOWDRAG|REPORTMOUSE|RMBTRAP
#define VERSION      "Text Plus V2.2E                        06.08.1990 by Martin Steppler"

struct NewScreen NeuScheibe = {
   0,0,640,200, 2, 0,1,
   HIRES,CUSTOMSCREEN, NULL,
   (UBYTE *) "Text Plus V2.2E                        06.08.1990 by Martin Steppler",
   NULL, NULL
};
struct NewWindow nw = {
   0,1,640,199,0,1,
   IDCMPFLAGS, FLAGS,
   NULL, NULL, EOS, NULL, NULL,
   640,96,640,200,
   CUSTOMSCREEN
};
